
# pma.py -o SocketFSMA Socket SocketSendA
# 47 states, 100 transitions, 17 accepting states, 4 finished and 0 deadend states

# actions here are just labels, but must be symbols with __name__ attribute

def send_return(): pass
def send_call(): pass
def send_close(): pass
def send_exception(): pass
def recv_close(): pass
def recv_call(): pass
def recv_return(): pass

# states, key of each state here is its number in graph etc. below

states = {
  0 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': ''}},
  1 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': ''}},
  2 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': ''}},
  3 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': False, 'buffers': ''}},
  4 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': ''}},
  5 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': ''}},
  6 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 4, 'send_closed': False, 'buffers': ''}},
  7 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'a'}},
  8 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': ''}},
  9 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': True, 'buffers': ''}},
  10 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'a'}},
  11 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': False, 'buffers': 'a'}},
  12 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'a'}},
  13 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'a'}},
  14 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'a'}},
  15 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'a'}},
  16 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 4, 'send_closed': False, 'buffers': 'a'}},
  17 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': True, 'buffers': 'a'}},
  18 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aa'}},
  19 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aa'}},
  20 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aa'}},
  21 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aa'}},
  22 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aa'}},
  23 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aa'}},
  24 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aa'}},
  25 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aa'}},
  26 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': True, 'buffers': 'aa'}},
  27 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaa'}},
  28 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaa'}},
  29 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aaa'}},
  30 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaa'}},
  31 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aaa'}},
  32 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaa'}},
  33 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aaa'}},
  34 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aaa'}},
  35 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': True, 'buffers': 'aaa'}},
  36 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaa'}},
  37 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaa'}},
  38 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aaaa'}},
  39 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaa'}},
  40 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aaaa'}},
  41 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': 'a', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaa'}},
  42 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': True, 'buffers': 'aaaa'}},
  43 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 4, 'send_closed': True, 'buffers': 'aaaa'}},
  44 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': 'a', 'recv_arg': 4, 'send_closed': False, 'buffers': 'aaaa'}},
  45 : {'Socket': {'exception': '', 'recv_closed': False, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaaa'}},
  46 : {'Socket': {'exception': '', 'recv_closed': True, 'send_arg': '', 'recv_arg': 0, 'send_closed': False, 'buffers': 'aaaaa'}},
}

# initial state, accepting states, frontier states, deadend states

initial = 0
accepting = [0, 2, 4, 8, 10, 13, 15, 19, 22, 24, 28, 31, 33, 37, 40, 42, 46]
frontier = [42, 43, 44, 45, 46]
finished = [8, 15, 24, 33]
deadend = []
runstarts = [0]

# finite state machine, list of tuples: (current, (action, args, result), next)

graph = (
  (0, (send_call, ('a',), None), 1),
  (0, (recv_close, (), None), 2),
  (0, (recv_call, (4,), None), 3),
  (0, (send_close, (), None), 4),
  (1, (recv_close, (), None), 5),
  (1, (recv_call, (4,), None), 6),
  (1, (send_return, (1,), None), 7),
  (2, (send_call, ('a',), None), 5),
  (2, (send_close, (), None), 8),
  (3, (send_call, ('a',), None), 6),
  (3, (send_close, (), None), 9),
  (4, (recv_close, (), None), 8),
  (4, (recv_call, (4,), None), 9),
  (5, (send_return, (1,), None), 10),
  (6, (send_return, (1,), None), 11),
  (7, (send_call, ('a',), None), 12),
  (7, (recv_close, (), None), 10),
  (7, (recv_call, (4,), None), 11),
  (7, (send_close, (), None), 13),
  (9, (recv_return, (0,), ''), 4),
  (10, (send_call, ('a',), None), 14),
  (10, (send_close, (), None), 15),
  (11, (send_call, ('a',), None), 16),
  (11, (send_close, (), None), 17),
  (11, (recv_return, (1,), 'a'), 0),
  (12, (recv_close, (), None), 14),
  (12, (recv_call, (4,), None), 16),
  (12, (send_return, (1,), None), 18),
  (13, (recv_close, (), None), 15),
  (13, (recv_call, (4,), None), 17),
  (14, (send_return, (1,), None), 19),
  (16, (send_return, (1,), None), 20),
  (16, (recv_return, (1,), 'a'), 1),
  (17, (recv_return, (0,), ''), 13),
  (17, (recv_return, (1,), 'a'), 4),
  (18, (send_call, ('a',), None), 21),
  (18, (recv_close, (), None), 19),
  (18, (recv_call, (4,), None), 20),
  (18, (send_close, (), None), 22),
  (19, (send_call, ('a',), None), 23),
  (19, (send_close, (), None), 24),
  (20, (send_call, ('a',), None), 25),
  (20, (recv_return, (2,), 'aa'), 0),
  (20, (send_close, (), None), 26),
  (20, (recv_return, (1,), 'a'), 7),
  (21, (recv_close, (), None), 23),
  (21, (recv_call, (4,), None), 25),
  (21, (send_return, (1,), None), 27),
  (22, (recv_close, (), None), 24),
  (22, (recv_call, (4,), None), 26),
  (23, (send_return, (1,), None), 28),
  (25, (recv_return, (2,), 'aa'), 1),
  (25, (send_return, (1,), None), 29),
  (25, (recv_return, (1,), 'a'), 12),
  (26, (recv_return, (2,), 'aa'), 4),
  (26, (recv_return, (0,), ''), 22),
  (26, (recv_return, (1,), 'a'), 13),
  (27, (send_call, ('a',), None), 30),
  (27, (recv_close, (), None), 28),
  (27, (recv_call, (4,), None), 29),
  (27, (send_close, (), None), 31),
  (28, (send_call, ('a',), None), 32),
  (28, (send_close, (), None), 33),
  (29, (send_call, ('a',), None), 34),
  (29, (recv_return, (2,), 'aa'), 7),
  (29, (send_close, (), None), 35),
  (29, (recv_return, (3,), 'aaa'), 0),
  (29, (recv_return, (1,), 'a'), 18),
  (30, (recv_close, (), None), 32),
  (30, (recv_call, (4,), None), 34),
  (30, (send_return, (1,), None), 36),
  (31, (recv_close, (), None), 33),
  (31, (recv_call, (4,), None), 35),
  (32, (send_return, (1,), None), 37),
  (34, (recv_return, (2,), 'aa'), 12),
  (34, (recv_return, (3,), 'aaa'), 1),
  (34, (send_return, (1,), None), 38),
  (34, (recv_return, (1,), 'a'), 21),
  (35, (recv_return, (2,), 'aa'), 13),
  (35, (recv_return, (3,), 'aaa'), 4),
  (35, (recv_return, (0,), ''), 31),
  (35, (recv_return, (1,), 'a'), 22),
  (36, (send_call, ('a',), None), 39),
  (36, (recv_close, (), None), 37),
  (36, (recv_call, (4,), None), 38),
  (36, (send_close, (), None), 40),
  (37, (send_call, ('a',), None), 41),
  (37, (send_close, (), None), 42),
  (38, (send_close, (), None), 43),
  (38, (recv_return, (1,), 'a'), 27),
  (38, (send_call, ('a',), None), 44),
  (38, (recv_return, (3,), 'aaa'), 7),
  (38, (recv_return, (4,), 'aaaa'), 0),
  (38, (recv_return, (2,), 'aa'), 18),
  (39, (recv_close, (), None), 41),
  (39, (recv_call, (4,), None), 44),
  (39, (send_return, (1,), None), 45),
  (40, (recv_close, (), None), 42),
  (40, (recv_call, (4,), None), 43),
  (41, (send_return, (1,), None), 46),
)
